]> git.immae.eu Git - perso/Immae/Config/Nix.git/blobdiff - nixops/scripts/setup
Refactor configuration and overlays
[perso/Immae/Config/Nix.git] / nixops / scripts / setup
index 929b27a3b6db719114fb594b03e49a74b6cb9aaf..1586265d48faae553f7122b81a79e2833f266120 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-set -euxo pipefail
+set -euo pipefail
 
 RemoteRepo="gitolite@git.immae.eu:perso/Immae/Prive/Password_store/Sites"
 DeploymentUuid="cef694f3-081d-11e9-b31f-0242ec186adf"
@@ -52,6 +52,34 @@ if ! pass $NIXOPS_CONFIG_PASS_SUBTREE_PATH > /dev/null 2>/dev/null; then
   fi
 fi
 
+# Repull it before using it, just in case
+pass git subtree pull --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
+
+gpg_keys=$(pass ls $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys | sed -e "1d" | cut -d" " -f2)
+for key in $gpg_keys; do
+  content=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys/$key)
+  fpr=$(echo "$content" | gpg --import-options show-only --import --with-colons | grep -e "^pub" | cut -d':' -f5)
+  gpg --list-key "$fpr" >/dev/null 2>/dev/null && imported=yes || imported=no
+  # /usr/share/doc/gnupg/DETAILS field 2
+  (echo "$content" | gpg --import-options show-only --import --with-colons |
+      grep -E '^pub:' |
+      cut -d':' -f2 |
+      grep -q '[fu]') && signed=yes || signed=no
+  if [ "$signed" = no -o "$imported" = no ] ; then
+    echo "The key for $key needs to be imported and signed (a local signature is enough)"
+    echo "$content" | gpg --import-options show-only --import
+    echo "Continue? [y/N]"
+    read y
+    if [ "$y" = "y" -o "$y" = "Y" ]; then
+      echo "$content" | gpg --import
+      gpg --expert --edit-key "$fpr" lsign quit
+    else
+      echo "Aborting"
+      exit 1
+    fi
+  fi
+done
+
 nix_group=$(stat -c %G /nix/store)
 if [ "$nix_group" = "nixbld" ]; then
   nix_user="nixbld1"
@@ -93,31 +121,26 @@ if [ ! -f /etc/ssh/ssh_rsa_key_nixops ]; then
   fi
 fi
 
-if ! which nixops 2>/dev/null >/dev/null; then
+if nix show-config --json | jq -e '.sandbox.value == "true"' >/dev/null; then
   cat <<-EOF
-       nixops is needed:
-       > nix-env -i nixops
-       If it fails, please check that $HOME/.nix-profile/bin is in your PATH.
-       Continue? [y/N]
+       There are some impure derivations in the repo currently (grep __noChroot), please put
+         sandbox = "relaxed"
+       in /etc/nix/nix.conf
+       you may also want to add
+         keep-outputs = true
+         keep-derivations = true
+       to prevent garbage collector from deleting build dependencies (they take a lot of time to build)
        EOF
-  read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    nix-env -i nixops
-    if ! which nixops 2>/dev/null >/dev/null; then
-      echo "Installation failed, please check that $HOME/.nix-profile/bin is in your path."
-      exit 1
-    fi
-  else
-    echo "Aborting"
-    exit 1
-  fi
+  exit 1
 fi
 
 DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
+source $(dirname $(dirname $DIR))/nix_path_env
+nixops="$(nix-build --no-out-link "$(dirname $DIR)/custom_nixops.nix")/bin/nixops"
 export NIXOPS_STATE="$(dirname $DIR)/state/eldiron.nixops"
 export NIXOPS_DEPLOYMENT="$DeploymentUuid"
 
-if ! nixops info 2>/dev/null >/dev/null; then
+if ! $nixops info 2>/dev/null >/dev/null; then
   cat <<-EOF
        Importing deployment file into nixops:
        Continue? [y/N]
@@ -125,9 +148,9 @@ if ! nixops info 2>/dev/null >/dev/null; then
   read y
   if [ "$y" = "y" -o "$y" = "Y" ]; then
     deployment=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/Deployment)
-    echo "$deployment" | nixops import
+    echo "$deployment" | $nixops import
 
-    nixops modify "$(dirname $DIR)/eldiron.nix"
+    $nixops modify "$(dirname $DIR)/eldiron.nix"
   else
     echo "Aborting"
     exit 1